package com.aliyun.batchcompute.job;

import com.aliyun.oss.OSSClient;
import com.aliyun.oss.model.OSSObject;
import com.aliyun.oss.model.ObjectMetadata;

import java.io.*;

public class Find {

    public static void main(String[] args){

        //环境变量
        String ossHost = System.getenv("ALI_DIKU_OSS_HOST");
        String taskId = System.getenv("ALI_DIKU_TASK_ID");
        String instanceId = System.getenv("ALI_DIKU_INSTANCE_ID");

        //todo: 需要修改的变量
        String findInputPath = "programs/find-prime/input-data-"+instanceId+".txt";
        String findOutputPath = "programs/find-prime/data/"+taskId+"-result-"+instanceId;


        OSSClient ossClient = new OSSClient(ossHost, Const.ACCESS_KEY_ID, Const.ACCESS_KEY_SECRET);

        OSSObject ossObject = ossClient.getObject(Const.BUCKET, findInputPath);

        InputStream is = ossObject.getObjectContent();

        String inputString = Util.getStringFromInputStream(is);

        String[] arr = inputString.split(" ");

        StringBuilder result = new StringBuilder();
        for(String num : arr){
            int n = Integer.parseInt(num.trim());

            if(isPrimeNum(n)){

                System.out.println(n+" is prime");
                result.append(n).append(" ");
            }
        }

        String resultStr = result.toString().trim();

        InputStream resultIs = new ByteArrayInputStream(resultStr.getBytes());

        ossClient.putObject(Const.BUCKET, findOutputPath, resultIs, new ObjectMetadata());

    }



    private static boolean isPrimeNum(int n){
        if(n <= 1){
            return false;
        }

        int i=2;
        while(i * i <= n){
            if( n % i == 0){
                return false;
            }
            i += 1;
        }
        return true;
    }
}
